//11. gyakorlat
//3. kvíz kérdés
#include <iostream>
#include <vector>
#include "plant.h"

using namespace std;
//#define Teszt1
//#define Belsoteszt

int main()
{
    cout << "Novenyek" << endl;
#ifdef Teszt1
    vector<Noveny> x;
    int ido=0;
    Borso b;
    x.push_back(b);
    Szegfu s1,s2;
    x.push_back(s1); x.push_back(s2);
    Hagyma h;
    x.push_back(h);
    Rozsa r1,r2;
    x.push_back(r1); x.push_back(r2);
    for(int i=0; i<(int)x.size(); ++i){ido+=x[i].getEresido();}
    #ifdef Belsoteszt
        //Ez mindenképp jó, akár virtual akár nem a Noveny osztály getEresido() metódusa
        cout<<s1.getEresido()<<endl;
        Noveny uj=s1;
        //Így mindenképp a Noveny osztály metódusa hívódik meg, nulla lesz az érési idő
        //akár virtuális, akár nem a Noveny osztály getEresido() metódusa
        cout<<uj.getEresido()<<endl; //mindig nulla
        //Ez jól működik, ha virtual a Noveny osztály getEresido() metódusa
        Noveny* ujp=&s1;
        cout<<ujp->getEresido()<<endl;
    #endif
#else
    vector<Noveny*> x;
    int ido=0;
    Borso* b=new Borso;
    x.push_back(b);
    Szegfu* s1=new Szegfu; Szegfu* s2=new Szegfu;
    x.push_back(s1); x.push_back(s2);
    Hagyma* h=new Hagyma;
    x.push_back(h);
    Rozsa* r1=new Rozsa; Rozsa* r2=new Rozsa;
    x.push_back(r1); x.push_back(r2);
    for(int i=0; i<(int)x.size(); ++i){ido+=x[i]->getEresido();}
    #ifdef Belsoteszt
        //Novenyre mutato pointerrel hivatkozunk az objektumokra
        //Csak akkor működik jól, ha Noveny osztályban virtual a getEresido()
        //Ha nem virtual nullát fog kiírni
        Noveny* np=s1;
        cout<<(*np).getEresido()<<endl;
        cout<<np->getEresido()<<endl;
        //Leszármazott típusra mutató pointerrel hivatkozunk az objetumokra
        //Akár virtual a Noveny osztály getEresido() metódusa, akár nem,
        //helyesen működik
        cout<<(*s1).getEresido()<<endl;
        cout<<s1->getEresido()<<endl;
    #endif

    //new-val lefoglalt objektumok felszabadítása
    for(int i=0; i<(int)x.size(); ++i){delete x[i];}
#endif

    cout<<"Ossz eresido: "<<ido<<endl;

    return 0;
}
